org.modeshape.jcr.value.binary

## Class FileSystemBinaryStore

- java.lang.Object
- - org.modeshape.jcr.value.binary.AbstractBinaryStore
  - - org.modeshape.jcr.value.binary.FileSystemBinaryStore

- All Implemented Interfaces:
    BinaryStore
  Direct Known Subclasses:
    TransientBinaryStore

      @ThreadSafe
      public class FileSystemBinaryStore
      extends AbstractBinaryStore

  A `BinaryStore` that stores files in a directory on the file system. The store does use file locks to prevent other processes from concurrently writing the files, and it also uses an internal set of locks to prevent mulitple threads from simultaneously writing to the persisted files.

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected static String` | `TRASH_DIRECTORY_NAME`

    - ### Fields inherited from class org.modeshape.jcr.value.binary.AbstractBinaryStore

      `logger, MEDIUM_BUFFER_SIZE`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `FileSystemBinaryStore(File directory)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `static FileSystemBinaryStore` | `create(File directory)`
    `protected File` | `findFile(File directory, BinaryKey key, boolean createParentDirsIfMissing)`
    `Iterable<BinaryKey>` | `getAllBinaryKeys()` Obtain an iterable implementation containing all of the store's binary keys of those binaries that are in use.
    `File` | `getDirectory()`
    `String` | `getExtractedText(BinaryValue source)` Returns the extracted text of a binary value, or `null` if such text hasn't been stored previously (but the binary value can be found in the store)
    `InputStream` | `getInputStream(BinaryKey key)` Get an `InputStream` to the binary content with the supplied key.
    `protected String` | `getStoredMimeType(BinaryValue binaryValue)` Returns the stored mime-type of a binary value.
    `protected void` | `initializeStorage(File directory)`
    `protected void` | `markAsUnused(BinaryKey key)`
    `void` | `markAsUnused(Iterable<BinaryKey> keys)` Mark the supplied binary keys as unused, but keep them in quarantine until needed again (at which point they're removed from quarantine) or until `BinaryStore.removeValuesUnusedLongerThan(long, TimeUnit)` is called.
    `void` | `markAsUsed(Iterable<BinaryKey> keys)` Marks the binary with supplied keys as used.
    `protected void` | `moveFileExclusively(File original, File destination, BinaryKey key)`
    `protected void` | `pruneEmptyDirectories(File directory, File removeable)` Remove any empty directories above `removeable` but below `directory`
    `protected boolean` | `removeAllTrashFilesFor(BinaryKey key)`
    `void` | `removeValuesUnusedLongerThan(long minimumAge, TimeUnit unit)` Remove binary values that have been `unused` for at least the specified amount of time.
    `void` | `storeExtractedText(BinaryValue source, String extractedText)` Stores the extracted text of a binary value into this store.
    `protected void` | `storeMimeType(BinaryValue binaryValue, String mimeType)` Stores the given mime-type for a binary value.
    `BinaryValue` | `storeValue(InputStream stream, boolean markAsUnused)` Store the binary value and return the JCR representation.
    `protected void` | `touch(File file)`

    - ### Methods inherited from class org.modeshape.jcr.value.binary.AbstractBinaryStore

      `bestBufferSize, detector, extractors, getMimeType, getMinimumBinarySizeInBytes, getText, hasBinary, setMimeTypeDetector, setMinimumBinarySizeInBytes, setTextExtractors, shutdown, start, storeValue`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### TRASH_DIRECTORY_NAME

          protected static final String TRASH_DIRECTORY_NAME

      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### FileSystemBinaryStore

          protected FileSystemBinaryStore(File directory)

  - ### Method Detail

    - #### create

          public static FileSystemBinaryStore create(File directory)

    - #### getDirectory

          public File getDirectory()

    - #### storeValue

          public BinaryValue storeValue(InputStream stream,
                               boolean markAsUnused)
                                 throws BinaryStoreException

      Description copied from interface: `BinaryStore`
      Store the binary value and return the JCR representation. Note that if the binary content in the supplied stream is already persisted in the store, the store may simply return the binary value referencing the existing content.
      Parameters:
        `stream` - the stream containing the binary content to be stored; may not be null
        `markAsUnused` - a `boolean` which indicates if the binary will be stored as unused or not. Binaries used from normal sessions (via properties) will normally be stored as unused and they will be marked as used only on tx commit.
      Returns:
        the binary value representing the stored binary value; never null
      Throws:
        `BinaryStoreException` - if there any unexpected problem

    - #### moveFileExclusively

          protected final void moveFileExclusively(File original,
                                 File destination,
                                 BinaryKey key)
                                            throws BinaryStoreException

      Throws:
        `BinaryStoreException`

    - #### findFile

          protected final File findFile(File directory,
                      BinaryKey key,
                      boolean createParentDirsIfMissing)
                                 throws BinaryStoreException

      Throws:
        `BinaryStoreException`

    - #### getInputStream

          public InputStream getInputStream(BinaryKey key)
                                     throws BinaryStoreException

      Description copied from interface: `BinaryStore`
      Get an `InputStream` to the binary content with the supplied key. The input stream will be returned as long as the binary value has not been removed, so expired binary values should be included here as well.
      Parameters:
        `key` - the key to the binary content; never null
      Returns:
        the input stream through which the content can be read, `never null`
      Throws:
        `BinaryStoreException` - if there is a problem reading the content from the store or if a valid, non-null `InputStream` cannot be returned for the given key.

    - #### initializeStorage

          protected void initializeStorage(File directory)
                                    throws BinaryStoreException

      Throws:
        `BinaryStoreException`

    - #### markAsUsed

          public void markAsUsed(Iterable<BinaryKey> keys)
                          throws BinaryStoreException

      Description copied from interface: `BinaryStore`
      Marks the binary with supplied keys as used. This method should ignore any keys which are not present in the store.
      Parameters:
        `keys` - a `BinaryKey` `Iterable`, may not be null
      Throws:
        `BinaryStoreException` - if anything unexpected fails.

    - #### removeAllTrashFilesFor

          protected boolean removeAllTrashFilesFor(BinaryKey key)
                                            throws BinaryStoreException

      Throws:
        `BinaryStoreException`

    - #### markAsUnused

          public void markAsUnused(Iterable<BinaryKey> keys)
                            throws BinaryStoreException

      Description copied from interface: `BinaryStore`
      Mark the supplied binary keys as unused, but keep them in quarantine until needed again (at which point they're removed from quarantine) or until `BinaryStore.removeValuesUnusedLongerThan(long, TimeUnit)` is called. This method ignores any keys for values not stored within this store.
      Parameters:
        `keys` - the keys for the binary values that are no longer needed
      Throws:
        `BinaryStoreException` - if there is a problem marking any of the supplied binary values as unused

    - #### markAsUnused

          protected void markAsUnused(BinaryKey key)
                               throws BinaryStoreException

      Throws:
        `BinaryStoreException`

    - #### touch

          protected void touch(File file)
                        throws BinaryStoreException

      Throws:
        `BinaryStoreException`

    - #### pruneEmptyDirectories

          protected void pruneEmptyDirectories(File directory,
                                   File removeable)

      Remove any empty directories above `removeable` but below `directory`
      Parameters:
        `directory` - the top-level directory to keep; may not be null and must be an ancestor of `removeable`
        `removeable` - the file or directory above which any empty directories can be removed; may not be null

    - #### removeValuesUnusedLongerThan

          public void removeValuesUnusedLongerThan(long minimumAge,
                                          TimeUnit unit)
                                            throws BinaryStoreException

      Description copied from interface: `BinaryStore`
      Remove binary values that have been `unused` for at least the specified amount of time.
      Parameters:
        `minimumAge` - the minimum time that a binary value has been `unused` before it can be removed; must be non-negative
        `unit` - the time unit for the minimum age; may not be null
      Throws:
        `BinaryStoreException` - if there is a problem removing the unused values

    - #### getExtractedText

          public String getExtractedText(BinaryValue source)
                                  throws BinaryStoreException

      Description copied from class: `AbstractBinaryStore`
      Returns the extracted text of a binary value, or `null` if such text hasn't been stored previously (but the binary value can be found in the store)
      Specified by:
        `getExtractedText` in class `AbstractBinaryStore`
      Parameters:
        `source` - a `non-null` `BinaryValue` instance from which the text was extracted
      Returns:
        a `String` representing the extracted text, or `null` if such text hasn't been stored in this store previously.
      Throws:
        `BinaryStoreException` - if the binary value cannot be found in the store.

    - #### storeExtractedText

          public void storeExtractedText(BinaryValue source,
                                String extractedText)
                                  throws BinaryStoreException

      Description copied from class: `AbstractBinaryStore`
      Stores the extracted text of a binary value into this store.
      Specified by:
        `storeExtractedText` in class `AbstractBinaryStore`
      Parameters:
        `source` - a `non-null` `BinaryValue` instance from which the text was extracted
        `extractedText` - a `non-null` and `non-blank` string representing the extracted text
      Throws:
        `BinaryStoreException` - if the operation fails or if the extracted text cannot be stored for the given binary value (regardless of the reason)

    - #### getStoredMimeType

          protected String getStoredMimeType(BinaryValue binaryValue)
                                      throws BinaryStoreException

      Description copied from class: `AbstractBinaryStore`
      Returns the stored mime-type of a binary value.
      Specified by:
        `getStoredMimeType` in class `AbstractBinaryStore`
      Parameters:
        `binaryValue` - a `non-null` `BinaryValue`
      Returns:
        either a non-empty `String` if a stored mimetype exists, or `null` if such a value doesn't exist yet.
      Throws:
        `BinaryStoreException` - if there's a problem accessing the binary store or if the binary value cannot be found in the store

    - #### storeMimeType

          protected void storeMimeType(BinaryValue binaryValue,
                           String mimeType)
                                throws BinaryStoreException

      Description copied from class: `AbstractBinaryStore`
      Stores the given mime-type for a binary value.
      Specified by:
        `storeMimeType` in class `AbstractBinaryStore`
      Parameters:
        `binaryValue` - a `non-null` `BinaryValue`
        `mimeType` - a non-empty `String`
      Throws:
        `BinaryStoreException` - if there's a problem accessing the binary store

    - #### getAllBinaryKeys

          public Iterable<BinaryKey> getAllBinaryKeys()
                                               throws BinaryStoreException

      Description copied from interface: `BinaryStore`
      Obtain an iterable implementation containing all of the store's binary keys of those binaries that are in use. The resulting iterator may be lazy, in the sense that it may determine additional `BinaryKey`s only as the iterator is used.
      Returns:
        the iterable set of binary keys; never null
      Throws:
        `BinaryStoreException` - if anything unexpected happens.

Copyright © 2008-2014 JBoss, a division of Red Hat. All Rights Reserved.